<template>
    <div>
        <crumbs title="版本信息维护">
            <el-form :inline="true" class="demo-form-inline">
                <el-form-item label="查询版本号：">
                    <el-input size="mini" v-model="filter.name" placeholder="输入版本号"></el-input>
                </el-form-item>
                <el-form-item>
                    <el-button size="mini" @click="filterDatas">确认</el-button>
                    <router-link to="/admin/LT-YXSJWH-TJBBXX" style="margin:0 10px">
                        <el-button size="mini" type="warning">添加版本信息</el-button>
                    </router-link>
                </el-form-item>
            </el-form>
        </crumbs>
        <div class="contents">
            <el-table :data="list"
                      border
                      style="width: 100%">
                <el-table-column
                        type="index"
                        :index="indexMethod"
                        label="编号"
                        width="60">
                </el-table-column>
                <el-table-column
                        prop="gmtCreate"
                        label="操作时间"
                        :show-overflow-tooltip="true">
                </el-table-column>
                <el-table-column
                        prop="name"
                        label="版本号">
                </el-table-column>
                <el-table-column
                        prop="refreshTime"
                        label="版本时间">
                </el-table-column>
                <el-table-column
                        prop="modifierid"
                        label="操作人">
                </el-table-column>
                <el-table-column
                        label="操作">
                    <template slot-scope="scope">
                        <el-button type="text" size="small" :class="{forbid:scope.row.id !=list[0].id}" @click="scope.row.id ==list[0].id?toEditVersion(scope.row):''">修改</el-button>
                    </template>
                </el-table-column>
                <el-table-column
                        label="详情">
                    <template slot-scope="scope">
                        <el-button type="text" size="small" @click="getDetail(scope.row)">详情</el-button>
                    </template>
                </el-table-column>
            </el-table>
            <el-pagination v-if="total>pageSize"
                           :current-page.sync="currentPage"
                           @current-change="currentChange"
                           background
                           :page-size="pageSize"
                           layout="total,prev, pager, next, jumper"
                           :total="total">
            </el-pagination>
        </div>

    </div>
</template>

<script>
  import api from '@api/icss.js';

  export default {
    name: 'VersionInfo',
    data: function () {
      return {
        list: [],
        cacheData: {},
        currentPage: 1,
        pageSize: 10,
        total: 0,
        filter: {
          name: ''
        }
      }
    },
    created() {
      this.getDataList();
    },
    methods: {
      toEditVersion(row){
        this.$router.push({
          name:'AddVersion',
          params: {info:row}
        })
      },
      filterDatas(){
        this.currentPage = 1;
        this.getDataList();
      },
      getDataList() {
        const param = this.getFilterItems();
        api.versionInfo(param).then((res) => {
          if (res.data.code == '0') {
            const data = res.data.data;
            this.list = data.records;
            this.cacheData[param.current] = data.records;
            this.total = data.total;
          }
        }).catch((error) => {
          console.log(error);
        });
      },
      getDetail(item) {
        let isFirst = item.id==this.list[0].id?true:false;
        this.$router.push({name:'VersionDetail', params:{info:item,isFirst}});
      },
      getFilterItems() {
        const param = {
          name: this.filter.name,
          current: this.currentPage,
          size: this.pageSize
        };
        return param;
      },
      indexMethod(index) {
        return ((this.currentPage - 1) * this.pageSize) + index + 1;
      },
      currentChange(next) {
        this.currentPage = next;
        if (this.cacheData[next]) {       //如果已请求过该页数据，则使用缓存不重复请求
          this.list = this.cacheData[next];
        } else {
          this.getDataList();
        }
      }
    }
  }
</script>

<style lang="less" scoped>
    @import "../../less/admin.less";
    .delete{
      color: red !important;
    }
    .forbid{
      color: #BFBFBF !important;
    }
</style>